Attribute VB_Name = "modGuild"
Public Const MAX_GUILD_MEMBERS As Long = 15
Public Const MAX_GUILD_RANKS As Long = 6
Public Const MAX_GUILD_RANKS_PERMISSION As Long = 6


Public GuildData As GuildRec

Public Type GuildRanksRec
    'General variables
    Used As Boolean
    name As String
    
    'Rank Variables
    RankPermission(1 To MAX_GUILD_RANKS_PERMISSION) As Byte
    RankPermissionName(1 To MAX_GUILD_RANKS_PERMISSION) As String
End Type

Public Type GuildMemberRec
    'User login/name
    Used As Boolean
    
    User_Login As String
    User_Name As String
    Founder As Boolean
    
    Online As Boolean
    
    'Guild Variables
    Rank As Integer
    Comment As String * 300
     
End Type

Public Type GuildRec
    In_Use As Boolean
    
    Guild_Name As String
    Guild_Tag As String
    
    'Guild file number for saving
    Guild_Fileid As Long
    
    Guild_Members(1 To MAX_GUILD_MEMBERS) As GuildMemberRec
    Guild_Ranks(1 To MAX_GUILD_RANKS) As GuildRanksRec
    
    'Message of the day
    Guild_MOTD As String * 115
    
    'The rank recruits start at
    Guild_RecruitRank As Integer
    Guild_Color As Integer

End Type
Public Sub HandleAdminGuild(ByVal Index As Long, ByRef Data() As Byte, ByVal StartAddr As Long, ByVal ExtraVar As Long)
Dim Buffer As clsBuffer
Dim I As Integer
Dim B As Integer

    If Options.Debug = 1 Then On Error GoTo errorhandler
    
    Set Buffer = New clsBuffer
    
    Buffer.WriteBytes Data()
    
    If Buffer.ReadByte = 1 Then
        frmGuildAdmin.Visible = True
    Else
        frmGuildAdmin.Visible = False
    End If

    
    Set Buffer = Nothing
    
    ' Error handler
    Exit Sub
errorhandler:
    HandleError "HandleAdminGuild", "modGuild", Err.Number, Err.Description, Err.Source, Err.HelpContext
    Err.Clear
End Sub
Public Sub HandleSendGuild(ByVal Index As Long, ByRef Data() As Byte, ByVal StartAddr As Long, ByVal ExtraVar As Long)
Dim Buffer As clsBuffer
Dim I As Integer
Dim B As Integer

    If Options.Debug = 1 Then On Error GoTo errorhandler
    
    Set Buffer = New clsBuffer
    
    Buffer.WriteBytes Data()
    
    GuildData.Guild_Name = Buffer.ReadString
    GuildData.Guild_Tag = Buffer.ReadString
    GuildData.Guild_Color = Buffer.ReadInteger
    GuildData.Guild_MOTD = Buffer.ReadString
    GuildData.Guild_RecruitRank = Buffer.ReadInteger
    
    'Get Members
    For I = 1 To MAX_GUILD_MEMBERS
        GuildData.Guild_Members(I).User_Name = Buffer.ReadString
        GuildData.Guild_Members(I).Rank = Buffer.ReadInteger
        GuildData.Guild_Members(I).Comment = Buffer.ReadString
        GuildData.Guild_Members(I).Online = Buffer.ReadByte
    Next I
    
    'Get Ranks
    For I = 1 To MAX_GUILD_RANKS
        GuildData.Guild_Ranks(I).name = Buffer.ReadString
        For B = 1 To MAX_GUILD_RANKS_PERMISSION
            GuildData.Guild_Ranks(I).RankPermission(B) = Buffer.ReadByte
            GuildData.Guild_Ranks(I).RankPermissionName(B) = Buffer.ReadString
        Next B
    Next I
    
    'Update Guildadmin data
    Call frmGuildAdmin.Load_Guild_Admin
    
    ' Reset Players Guild Tag/Name
    Player(MyIndex).GuildName = GuildData.Guild_Name
    Player(MyIndex).GuildTag = GuildData.Guild_Tag
    Player(MyIndex).GuildColor = GuildData.Guild_Color
    
    Set Buffer = Nothing
    
    
    ' Error handler
    Exit Sub
errorhandler:
    HandleError "HandleSendGuild", "modGuild", Err.Number, Err.Description, Err.Source, Err.HelpContext
    Err.Clear
End Sub
Public Sub GuildMsg(ByVal text As String)
Dim Buffer As clsBuffer

    ' If debug mode, handle error then exit out
    If Options.Debug = 1 Then On Error GoTo errorhandler
    
    Set Buffer = New clsBuffer
    Buffer.WriteLong CSayGuild
    Buffer.WriteString text
    SendData Buffer.ToArray()
    Set Buffer = Nothing
    
    ' Error handler
    Exit Sub
errorhandler:
    HandleError "GuildMsg", "modGuild", Err.Number, Err.Description, Err.Source, Err.HelpContext
    Err.Clear
    Exit Sub
End Sub

Public Sub GuildMake(ByVal Command As Integer, ByVal SendText As String, ByVal SendText2 As String)
Dim Buffer As clsBuffer

    ' If debug mode, handle error then exit out
    If Options.Debug = 1 Then On Error GoTo errorhandler
    
    Set Buffer = New clsBuffer
    Buffer.WriteLong CGuildCommand
    Buffer.WriteInteger Command
    Buffer.WriteString SendText
    Buffer.WriteString SendText2
    SendData Buffer.ToArray()
    Set Buffer = Nothing
    
    ' Error handler
    Exit Sub
errorhandler:
    HandleError "GuildMsg", "modGuild", Err.Number, Err.Description, Err.Source, Err.HelpContext
    Err.Clear
    Exit Sub
End Sub

Public Sub GuildCommand(ByVal Command As Integer, ByVal SendText As String)
Dim Buffer As clsBuffer

    ' If debug mode, handle error then exit out
    If Options.Debug = 1 Then On Error GoTo errorhandler
    
    Set Buffer = New clsBuffer
    Buffer.WriteLong CGuildCommand
    Buffer.WriteInteger Command
    Buffer.WriteString SendText
    SendData Buffer.ToArray()
    Set Buffer = Nothing
    
    ' Error handler
    Exit Sub
errorhandler:
    HandleError "GuildMsg", "modGuild", Err.Number, Err.Description, Err.Source, Err.HelpContext
    Err.Clear
    Exit Sub
End Sub

Public Sub GuildSave(ByVal SaveType As Integer, ByVal Index As Integer)
Dim Buffer As clsBuffer
Dim I As Integer
Dim B As Integer
'SaveType
'1=options
'2=users
'3=ranks
 If Index = 0 Then Exit Sub


    ' If debug mode, handle error then exit out
    If Options.Debug = 1 Then On Error GoTo errorhandler
    
    Set Buffer = New clsBuffer
    Buffer.WriteLong CSaveGuild
    
    Buffer.WriteInteger SaveType
    Buffer.WriteInteger Index
    
    Select Case SaveType
    Case 1
        'options
        Buffer.WriteInteger GuildData.Guild_Color
        Buffer.WriteInteger GuildData.Guild_RecruitRank
        Buffer.WriteString GuildData.Guild_Name
        Buffer.WriteString GuildData.Guild_Tag
        Buffer.WriteString GuildData.Guild_MOTD
    Case 2
        'users
        Buffer.WriteInteger GuildData.Guild_Members(Index).Rank
        Buffer.WriteString GuildData.Guild_Members(Index).Comment
    Case 3
        'ranks
        Buffer.WriteString GuildData.Guild_Ranks(Index).name
        For I = 1 To MAX_GUILD_RANKS_PERMISSION
            Buffer.WriteByte GuildData.Guild_Ranks(Index).RankPermission(I)
        Next I
    End Select

    SendData Buffer.ToArray()
    Set Buffer = Nothing
    
    ' Error handler
    Exit Sub
errorhandler:
    HandleError "GuildMsg", "modGuild", Err.Number, Err.Description, Err.Source, Err.HelpContext
    Err.Clear
    Exit Sub
End Sub

Public Sub HandleGuildInvite(ByVal Index As Long, ByRef Data() As Byte, ByVal StartAddr As Long, ByVal ExtraVar As Long)
Dim Buffer As clsBuffer
Dim GName As String
Dim GInvName As String

' If debug mode, handle error then exit out
If Options.Debug = 1 Then On Error GoTo errorhandler

Set Buffer = New clsBuffer
Buffer.WriteBytes Data()

GName = Buffer.ReadString
GInvName = Buffer.ReadString

Dialogue "Guild Invitation:", GInvName & " has invited you to their guild." & vbNewLine & "Guild Name: " & GName & vbNewLine & _
" want to Join?", DIALOGUE_TYPE_GUILDINVITE, True


' Error handler
Exit Sub
errorhandler:
HandleError "HandleAdminGuild", "modGuild", Err.Number, Err.Description, Err.Source, Err.HelpContext
Err.Clear
End Sub
